#include <sys/types.h>
#include <sys/ioctl.h>
#include <sys/socket.h>

#include <stdio.h>
#include <string.h>
#include <assert.h>
#include <stdlib.h>

#include <unistd.h>

#include <netinet/in.h>
#include <net/if.h>
#include <linux/if_packet.h>
#include <linux/if_ether.h>
#include <sys/time.h>
#include <time.h>

#define __packed __attribute__((__packed__))
#include  "ieee80211.h"

//int data_pkt = 0;
//int data_bytes = 0;
    

int monitor(char *dev, int data_bytes)
{
    /*struct ifreq ifr;
    struct sockaddr_ll ll;
    const int protocol = ETH_P_ALL;
    int sock = -1;*/
    //int num_pkt = 0;
    //int data_pkt = 0;
    data_bytes = 0;
   
    /* assert(sizeof(ifr.ifr_name) == IFNAMSIZ);
    
    const char* device = dev;
    sock = socket(PF_PACKET, SOCK_RAW, htons(protocol));
    if (sock < 0)
    {
	    perror("socket failed\n");
	    return -1;
    }
    memset(&ifr, 0, sizeof(ifr));
    strncpy(ifr.ifr_name, device, sizeof(ifr.ifr_name));
    /*ifr.ifr_flags |= IFF_PROMISC;
    if(ioctl(sock, SIOCSIFFLAGS, &ifr) < 0)
    {
            perror("SIOCSIFFLAGS");
	    return -1;
    }*/
    if(ioctl(sock, SIOCGIFINDEX, &ifr) < 0)
    {
	    perror("ioctl[SIOCGIFINDEX]");
	    close(sock);
	    return -1;
    }
    memset(&ll, 0, sizeof(ll));
    ll.sll_family = AF_PACKET;
    ll.sll_ifindex = ifr.ifr_ifindex;
    ll.sll_protocol = htons(protocol);
    if(bind(sock, (struct sockaddr *)&ll, sizeof(ll)) < 0) {
	    perror("bind[AF_PACKET]");
	    close(sock);
	    return -1;
    }*/
    while (1) 
    {
            fd_set readfds;
	    FD_ZERO(&readfds);
	    FD_SET(sock, &readfds);
	    int numFds = select(sock+1, &readfds, NULL, NULL, NULL); //never timeout
	    assert(numFds >= 0);
	    if(numFds < 0)
	    {
                   perror("select failed");
		   return 1;
	    }
	    if(numFds == 1)
	    {
                   uint8_t packetBuffer[4096];
		   ssize_t bytes = read(sock, packetBuffer, sizeof(packetBuffer));
		   //struct msghdr packetBuffer;
		   //ssize_t bytes = recvmsg(sock, &packetBuffer, 0);
		   if(bytes < 0)
		   { 
			   perror("read failed");
			   return 1;
		   }
		   if(bytes != 0) {
			   //num_pkt++;
			   //printf("number of total packets is %d\n", num_pkt);
			   struct ieee80211_frame* mac_hdr = (struct ieee80211_frame*) packetBuffer;
			   if ( (mac_hdr->i_fc[0] & IEEE80211_FC0_TYPE_MASK) == IEEE80211_FC0_TYPE_DATA ) {
			       data_pkt++;
			       data_bytes += bytes;
			       printf("number of received DATA packets is %d\n", data_pkt);
			       printf("Packet length is %d bytes\n", bytes);
			   }
		   }
	    }
	    
	    /*if(num_pkt % 5 == 0)
		    printf("number of received packets is %d\n", num_pkt); */
    }
    return data_pkt;
}

